/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VIsVariableRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VIsVariable extends TableImpl<VIsVariableRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_is_variable</code>
     */
    public static final VIsVariable V_IS_VARIABLE = new VIsVariable();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VIsVariableRecord> getRecordType() {
        return VIsVariableRecord.class;
    }

    /**
     * The column <code>common_dd.v_is_variable.key_element</code>.
     */
    public final TableField<VIsVariableRecord, Integer> KEY_ELEMENT = createField(DSL.name("key_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_is_variable.dn</code>.
     */
    public final TableField<VIsVariableRecord, String> DN = createField(DSL.name("dn"), SQLDataType.CLOB, this, "");

    private VIsVariable(Name alias, Table<VIsVariableRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VIsVariable(Name alias, Table<VIsVariableRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_is_variable" as  SELECT t_core_element_hierarchy.key_element,
          t_core_element_hierarchy.dn
         FROM (common_dd.t_core_element_hierarchy
           RIGHT JOIN common_dd.t_core_variable ON ((t_core_variable.key_variable = t_core_element_hierarchy.key_element)))
        WHERE (t_core_element_hierarchy.key_element IS NOT NULL);
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_is_variable</code> table reference
     */
    public VIsVariable(String alias) {
        this(DSL.name(alias), V_IS_VARIABLE);
    }

    /**
     * Create an aliased <code>common_dd.v_is_variable</code> table reference
     */
    public VIsVariable(Name alias) {
        this(alias, V_IS_VARIABLE);
    }

    /**
     * Create a <code>common_dd.v_is_variable</code> table reference
     */
    public VIsVariable() {
        this(DSL.name("v_is_variable"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VIsVariable as(String alias) {
        return new VIsVariable(DSL.name(alias), this);
    }

    @Override
    public VIsVariable as(Name alias) {
        return new VIsVariable(alias, this);
    }

    @Override
    public VIsVariable as(Table<?> alias) {
        return new VIsVariable(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VIsVariable rename(String name) {
        return new VIsVariable(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VIsVariable rename(Name name) {
        return new VIsVariable(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VIsVariable rename(Table<?> name) {
        return new VIsVariable(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsVariable where(Condition condition) {
        return new VIsVariable(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsVariable where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsVariable where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsVariable where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VIsVariable where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VIsVariable where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VIsVariable where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VIsVariable where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsVariable whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsVariable whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
